#include "Gra.ch"
#include "AppEvent.ch"
#include "Xbp.ch"
#include "Font.ch"
#include "common.ch"

PROCEDURE Appsys()
RETURN

PROCEDURE Main()
LOCAL nEvent, mp1, mp2, oXbp
LOCAL oDlg
LOCAL oStat, oPS, oFont,aMatrix
LOCAL nFaktor  := 1

   oDlg := XbpDialog():new( AppDesktop(), , {10,10}, {700,700}, , .F.)
   oDlg:taskList := .T.
   oDlg:title := "GRAPHICS STRING ROTATE"
   oDlg:create()
   oDlg:show()

   SetAppWindow( oDlg)
   SetAppFocus( oDlg)

   aMatrix  := GraInitMatrix()

   oStat := XbpStatic():new(oDlg:drawingArea,, { 0, 0}, { 700,700 },;
                                 {{XBP_PP_BGCLR,GRA_CLR_WHITE}}, .T.)
   oStat:paint := {|| Showme(oStat,oPS,aMatrix,nFaktor) }
   oStat:create()
   oStat:show()

   oPS      := XbpPresSpace():new():create( oStat:winDevice() )
   oPS:mode := XBPPS_MODE_HIGH_PRECISION

   oFont    := XbpFont():new(oPS):create()
   oFont:configure( FONT_DEFPROP_XLARGE )
   GraSetFont( oPS, oFont )

   nEvent := xbeP_None
   DO WHILE nEvent != xbeP_Close
       nEvent := AppEvent( @mp1, @mp2, @oXbp )
       DO CASE
          CASE nEvent = xbeP_Keyboard .AND. mp1 = xbeK_ESC
            EXIT

          CASE nEvent = xbeP_Keyboard .AND. mp1 = 43
            nFaktor++
            IF(nFaktor>10,nFaktor:=1,NIL)
            PostAppEvent(xbeP_Paint,,,oStat)

          CASE nEvent = xbeP_Keyboard .AND. mp1 = 45
            nFaktor--
            IF(nFaktor<1,nFaktor:=10,NIL)
            PostAppEvent(xbeP_Paint,,,oStat)

       OTHERWISE
          oXbp:handleEvent( nEvent, mp1, mp2 )
       ENDCASE
   ENDDO

   oDlg:destroy()

RETURN

PROCEDURE Showme(oStat,oPS,aMatrix,nFaktor)
LOCAL i,iMax
LOCAL aAttr := ARRAY( GRA_AS_COUNT )
LOCAL nSegment
LOCAL nGrad
LOCAL cText
LOCAL cTeil

STATIC nLast := 0

DEFAULT nFaktor TO 1

   IF nLast == nFaktor
   ELSE
      nLast := nFaktor
      oStat:invalidateRect()
   ENDIF

   cText := REPLICATE("A",12*nFaktor)

   iMax := LEN(cText)

   FOR i:=1 TO iMax
      nSegment := graSegOpen(oPs)
      nGrad    := 360/iMax*i

      DO CASE
         CASE nGrad >=   0 .AND. nGrad <=  45
            aAttr [ GRA_AS_COLOR ]     := GRA_CLR_BLUE
            aAttr [ GRA_AS_ANGLE ] := {1,i*-1}

         CASE nGrad >=  45 .AND. nGrad <=  90
            aAttr [ GRA_AS_COLOR ]     := GRA_CLR_RED

         CASE nGrad >=  90 .AND. nGrad <= 135
            aAttr [ GRA_AS_COLOR ]     := GRA_CLR_PINK
            aAttr [ GRA_AS_ANGLE ] := {i+1,(i-iMax)+1}

         CASE nGrad >= 135 .AND. nGrad <= 180
            aAttr [ GRA_AS_COLOR ]     := GRA_CLR_GREEN

         CASE nGrad >= 180 .AND. nGrad <= 225
            aAttr [ GRA_AS_COLOR ]     := GRA_CLR_CYAN

         CASE nGrad >= 225 .AND. nGrad <= 270
            aAttr [ GRA_AS_COLOR ]     := GRA_CLR_YELLOW

         CASE nGrad >= 270 .AND. nGrad <= 315
            aAttr [ GRA_AS_COLOR ]     := GRA_CLR_DARKBLUE

         CASE nGrad >= 315 .AND. nGrad <= 360
            aAttr [ GRA_AS_COLOR ]     := GRA_CLR_DARKRED

      ENDCASE

      GraSetAttrString( oPS, aAttr )
      cTeil := SUBSTR(cText,i,1)
      GraStringAt( oPS, {100,100}, cTeil )

      GraSegClose(oPS)

      GraRotate( oPS, aMatrix, 360/iMax, {330,330}, GRA_TRANSFORM_ADD )

      GraSegDraw(oPS, nSegment, aMatrix)

      GraSegDestroy( oPS, nSegment )
   NEXT

RETURN
